/* Program by Frank Damgaard, april. 1994 */
/*            frank@diku.dk             */
/* compiles under DOS (Turbo C++) or eqv.  */
/* compiles under unix: cc og gcc   (ANSI-C!)*/
/* convert textfiles DOS<->UNIX, CodePage 850 <-> latin1 (ISO 8859-1) */
/*  */
/*  9. april 1995: corrected errors in converting from cp850->8859-1 */
/*                 "" now converts correct. */
/*  */
#define VERSION "1.2"

#include <stdio.h>
#include <ctype.h>
#include <stdlib.h>
#ifdef __MSDOS__
#  include <fcntl.h>
#  include <io.h>
#endif

#define CP437 2
#define CP865 1
#define CP850 0
#define CP850G 1
#define Latin1 100
/*#define EOFZ /* */
#ifdef EOFZ
#define CTRLZ  26
#endif

  char	lx80tab[]= {
        '','','','','','','','',
        '','','','','','','',' ',
        ' ',' ',' ',' ',' ',' ',' ',' ',
	' ',' ',' ','\x18','\x1b','','','' };

  unsigned char from_latin1[3][256]={
	{ /* CP850 /  : */
	  0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15,
	 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31,
	' ','!','"','#','$','%','&', 39,'(',')','*','+',',','-','.','/',
	'0','1','2','3','4','5','6','7','8','9',':',';','<','=','>','?',
	'@','A','B','C','D','E','F','G','H','I','J','K','L','M','N','O',
	'P','Q','R','S','T','U','V','W','X','Y','Z','[', 92,']','^','_',
	'`','a','b','c','d','e','f','g','h','i','j','k','l','m','n','o',
	'p','q','r','s','t','u','v','w','x','y','z','{','|','}','~',127,
	/*  ascii > 127 : */
	' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',
	' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',
	' ','','','','','','','','','','','','','','','',
	'','','','','`','','','','','','','','','','','',
	'','','','','','','','','','','','','','','','',
	'','','','','','','','','','','','','','','','',
	'','','','','','','','','','','','','','','','',
	'','','','','','','','','','','','','','','',''},

	{/* CP865 /   : */
	  0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15,
	 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31,
	' ','!','"','#','$','%','&', 39,'(',')','*','+',',','-','.','/',
	'0','1','2','3','4','5','6','7','8','9',':',';','<','=','>','?',
	'@','A','B','C','D','E','F','G','H','I','J','K','L','M','N','O',
	'P','Q','R','S','T','U','V','W','X','Y','Z','[', 92,']','^','_',
	'`','a','b','c','d','e','f','g','h','i','j','k','l','m','n','o',
	'p','q','r','s','t','u','v','w','x','y','z','{','|','}','~',127,
	/*  ascii > 127 : */
	' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',
	' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',
	' ','',  0,'','',  0,'|',  0,  0,  0,'','','','-',  0,  0,
	'','','',  0,'`','',  0,'',  0,  0,'',  0,'','',  0,'',
	  0,  0,  0,  0,'','','','',  0,'',  0,  0,  0,  0,  0,  0,
	  0,'',  0,  0,  0,  0,'',  0,'',  0,  0,  0,'',  0,  0,'',
	'','','',  0,'','','','','','','','','','','','',
	  0,'','','','',  0,'','','','','','','',  0,  0,'' },
	{/* CP437 / : */
	  0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15,
	 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31,
	' ','!','"','#','$','%','&', 39,'(',')','*','+',',','-','.','/',
	'0','1','2','3','4','5','6','7','8','9',':',';','<','=','>','?',
	'@','A','B','C','D','E','F','G','H','I','J','K','L','M','N','O',
	'P','Q','R','S','T','U','V','W','X','Y','Z','[', 92,']','^','_',
	'`','a','b','c','d','e','f','g','h','i','j','k','l','m','n','o',
	'p','q','r','s','t','u','v','w','x','y','z','{','|','}','~',127,
	/*  ascii > 127 : */
	' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',
	' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',
	' ','','','',  0,'','|',  0,  0,  0,'','','','-',  0,  0,
	'','','',  0,'`','',  0,'',  0,  0,'','','','',  0,'',
	  0,  0,  0,  0,'','','','',  0,'',  0,  0,  0,  0,  0,  0,
	  0,'',  0,  0,  0,  0,'',  0,  0,  0,  0,  0,'',  0,  0,'',
	'','','',  0,'','','','','','','','','','','','',
	  0,'','','','',  0,'','',  0,'','','','',  0,  0,'' }};

  char to_latin1[2][256] = {
	{/* 850 -> Latin1   : */
	  0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15,
	 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31,
	' ','!','"','#','$','%','&', 39,'(',')','*','+',',','-','.','/',
	'0','1','2','3','4','5','6','7','8','9',':',';','<','=','>','?',
	'@','A','B','C','D','E','F','G','H','I','J','K','L','M','N','O',
	'P','Q','R','S','T','U','V','W','X','Y','Z','[', 92,']','^','_',
	'`','a','b','c','d','e','f','g','h','i','j','k','l','m','n','o',
	'p','q','r','s','t','u','v','w','x','y','z','{','|','}','~',127,
	/*  ascii > 127 : */
  /*                                                   */
/* old	162,252,233,226,228,224,229,231,234,235,232,239,238,236,196,197, */
	199,252,233,226,228,224,229,231,234,235,232,239,238,236,196,197,
  /*                                                   */
	201,230,198,244,246,242,251,249,255,214,220,248,163,216,215,  0,
  /*                                                   */
	225,237,243,250,241,209,170,186,191,174,172,189,188,161,171,187,
  /*                                                   */
/*old	  0,  0,  0,  0,  0,193,194,192,169,  0,  0,  0,  0,231,165,  0, */
	  0,  0,  0,  0,  0,193,194,192,169,  0,  0,  0,  0,162,165,  0,
  /*                                                   */
	  0,  0,  0,  0,  0,  0,227,195,  0,  0,  0,  0,  0,  0,  0,164,
  /*                                                   */
	240,208,202,203,200,  0,205,206,207,  0,  0,  0,  0,166,204,  0,
  /*                                                   */
	211,223,212,210,245,213,181,254,222,218,219,217,253,221,175,180,
  /*                                                    */
	173,177,  0,190,182,167,247,184,176,168,183,185,179,178,  0,  0 },

	{/* 850G -> Latin1, Grafic conversion /  : */
	  0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15,
	 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31,
	' ','!','"','#','$','%','&', 39,'(',')','*','+',',','-','.','/',
	'0','1','2','3','4','5','6','7','8','9',':',';','<','=','>','?',
	'@','A','B','C','D','E','F','G','H','I','J','K','L','M','N','O',
	'P','Q','R','S','T','U','V','W','X','Y','Z','[', 92,']','^','_',
	'`','a','b','c','d','e','f','g','h','i','j','k','l','m','n','o',
	'p','q','r','s','t','u','v','w','x','y','z','{','|','}','~',127,
	/*  ascii > 127 : */
  /*                                                   */
	199,252,233,226,228,224,229,231,234,235,232,239,238,236,196,197,
  /*                                                   */
	201,230,198,244,246,242,251,249,255,214,220,248,163,216,215,  0,
  /*                                                   */
	225,237,243,250,241,209,170,186,191,174,172,189,188,161,171,187,
  /*                                                   */
	'#','#','#','|','+',193,194,192,169,'+','|','+','+',162,165,'+',
  /*                                                   */
	'+','+','+','+','-','+',227,195,'+','+','+','+','+','-','+',164,
  /*                                                   */
	240,208,202,203,200,  0,205,206,207,'+','+','#','#',166,204,'#',
  /*                                                   */
	211,223,212,210,245,213,181,254,222,218,219,217,253,221,175,180,
  /*                                                    */
	173,177,'_',190,182,167,247,184,176,168,183,185,179,178,'#',  0 }};

unsigned char convert[256];
int  	to_cp, from_cp, same_cp;
int   	ffopt, lfopt, dkopt, testv;
char	*progname;
#ifdef EOFZ
int	do_z_eof;
#endif

char *emsg[]= {
	"%s vers. %s, Error 0x%x : in command ! \n",
	"Syntax: %s {-options} <inputfile> [outputfile]\n",
/*	"Under DOS: using output redirection disables option -L\n", /**/
	"Options:\n",
	"\t-l\tUNIX-newline: CR LF => LF\n",
	"\t-c\tDOS-newline: LF => CR LF\n",
	"\t-f\tNo FormFeeds\n",
	"\t-x\tEpson LX80 grafic => 8-bit IBM charset\n",
	"\t-sN\tSource     : 1 (Latin1) / 437 / 850 / 865\n",
	"\t-dN\tDestination: 1 (Latin1) / 2 / 850\n",
	"\t\t\t N=2 is Latin1, with grafic emulation of 850\n",
	"\t-uC\tUnmapable characters area mapped to character: C\n",
#ifdef EOFZ
	"\t-z\tDisable CTRL-Z as EOF character.\n",
#endif
#ifdef __MSDOS__
	"\t-8\t{|}[\\] => \n",
	"\t-7\t => {|}[\\]\n",
#else  /* Latin1 (unix) : */
	"\t-8\t{|}[\\] => \n",
	"\t-7\t => {|}[\\]\n",
#endif
	"" };

int errormsg(int err)
{
  char **cp;
  cp=emsg;
  if (! err) return 0;
  fprintf(stderr,*cp,progname,VERSION,err);
  if (err & 0x6000 )
     fprintf(stderr,"   Internal Error: can't allocate filebuffers.\n");
  cp++; fprintf(stderr,*cp,progname);
  for (; **(++cp) != 0; fputs(*cp,stderr) ) ;
  exit(-1);
  return -1;
}

#define CR 13
#define LF 10
#define FF 12

void do_convert(FILE *fin, FILE *fout)
{
    int c;
    int zeof;

    zeof=0;
    while (((c = getc(fin) ) != EOF) && ! zeof)
       switch (c) {
	 case FF: /* FormFeed */
		  if (! ffopt ) putc(c,fout);
		  break;
	 case CR: /* CarriageReturn*/
		  if (lfopt == 0) putc(CR,fout);
		  else {
		      if ( (c=getc(fin)) == LF ) {
			if (lfopt == -1) putc(CR,fout);
			putc(LF,fout);
		      } else ungetc(c,fout);
		  }
		  break;
	 case LF: /* LineFeed */
		  if (lfopt == -1) putc(CR,fout);
		  putc(LF,fout);
		  break;
#ifdef EOFZ
	 case CTRLZ: /* EOF , should not be possible in DOS */
		  zeof= do_z_eof;
		  break;
#endif
	 default:
		putc(convert[c],fout);
       }
    fclose(fout); fclose(fin);
}
#ifdef __MSDOS__
#  define RD_ACCMODE "rb"
#  define WR_ACCMODE "wb"
#  define BUF_SIZE 16384
#else
#  define RD_ACCMODE "r"
#  define WR_ACCMODE "w"
#endif

main (int argc, char *argv[])
{
  char *empty="\0";
  int  	arglc;
  int	lx80opt, errorflg;
  char 	unmap,*cp;
  int	i;
  int	 filenumber;
  FILE 	*fin, *fout;

#ifdef EOFZ
  do_z_eof=1;
#endif
  testv=lx80opt=lfopt=ffopt=dkopt=0;
  to_cp=CP850; from_cp=CP850;
  unmap = ' ';
  errorflg=0;
  filenumber=0;
  arglc = 0;  progname = argv[0];
  while ( ++arglc < argc) {
    cp = argv[arglc];
    if ((*cp == '-')||(*cp == '/')) {
	while (*(++cp) !='\0') {
	    *cp= tolower(*cp);
	    if (*cp == 'l') lfopt=1;
	    else if (*cp == 'c') lfopt=-1;
	    else if ( *cp == '8') dkopt=1;
	    else if ( *cp == '7') dkopt=-1;
	    else if ( *cp == 'f') ffopt=1;
	    else if ( *cp == 'x') lx80opt=1;
#ifdef EOFZ
	    else if ( *cp == 'z') do_z_eof=0;
#endif
	    else if ( *cp == 'u') { unmap= *(cp+1); if (unmap) cp++; }
	    else if ( *cp == 't') {
	      if ( sscanf(++cp,"%d",&testv) != 1 ) errorflg |=0x8000;
	    } else if ( *cp == 's') {
	      if ( sscanf(++cp,"%d",&from_cp) != 1 ) errorflg |=4;
	      else {
		from_cp = (from_cp==437)? CP437 :
				(from_cp==850)? CP850:
				  (from_cp==865) ? CP865:
					(from_cp==1) ? Latin1: -1 ;
		if (from_cp<0) errorflg |=8;
		cp=empty;
	      }
	    } else if ( *cp == 'd') {
	      if ( sscanf(++cp,"%d",&to_cp) != 1 ) errorflg |=0x40;
	      else {
		to_cp = (to_cp==437)? CP850 :
			    (to_cp==850)? CP850:
				(to_cp==865) ? CP850:
				    (to_cp==1) ? Latin1:
				      (to_cp==2) ? Latin1+CP850G-CP850: -1;
		if (to_cp<0) errorflg |=0x80;
		cp=empty;
	      }
	    } else errorflg += 1;
	}
    } else if (filenumber==0) {
      if ((fin=fopen(cp,RD_ACCMODE))==NULL) {
	errorflg|=0x200; fprintf(stderr,"Can't open %s for read\n",cp);
      }
      filenumber++;
    } else if (filenumber==1) {
      if ((fout = fopen(cp,WR_ACCMODE))==NULL) {
	errorflg|=0x400; fprintf(stderr,"Can't open %s for write\n",cp);
      }
      filenumber++;
    } else {
      fprintf(stderr,"Error too many files, %s\n",cp);
      errorflg |= 0x100;
    }
  }

  if ( ! errorflg ) {
#ifdef __MSDOS__
	if (filenumber <= 1) {
	    fout= stdout; setmode( fileno(fout), O_BINARY);
	}
	if (filenumber == 0) {
	    fin = stdin ; setmode( fileno(fin) , O_BINARY);
	}
	if( ! isatty(fileno(fin)) ) {
	  if ( setvbuf(fin, NULL, _IOFBF, BUF_SIZE) )
		errorflg  |= 0x4000;
	}
	if( ! isatty(fileno(fout)) ) {
	  if ( setvbuf(fout, NULL, _IOFBF, BUF_SIZE) )
		errorflg  |= 0x2000;
	}
#else
    if (filenumber <= 1) fout= stdout;
    if (filenumber == 0) fin= stdin;
#endif
  }
  if ( testv ) {
    fprintf( stderr,
	     "lfopt %d, lx80 %d, ff %d, dk %d, src %d, dest %d, %s %s.\n",
	     lfopt,lx80opt,ffopt,dkopt,from_cp,to_cp,RD_ACCMODE,WR_ACCMODE);
  }
  if (! errorflg ) {
    same_cp=((to_cp >99)&&(from_cp>99))||((to_cp<99)&&(from_cp<99)) ? 1 : 0;
    if (same_cp) for (i=-1; ++i < 256; convert[i]=i) ;
    else if (from_cp==Latin1)
	for (i=-1; ++i < 256; convert[i]=from_latin1[to_cp][i] ) ;
    else if (from_cp<99) {
	if (to_cp<99) for (i=-1; ++i < 256; convert[i]=to_latin1[0][i] ) ;
	else for (i=-1; ++i < 256; convert[i]=to_latin1[to_cp-Latin1][i] ) ;
    }
    if ( dkopt == 1 ) {
      if (to_cp==Latin1) {
	convert['[']=198; convert['\\']=216; convert[']']=197;
	convert['{']=230; convert['|'] =248; convert['}']=229;
      } else {
	convert['[']=146; convert['\\']=157; convert[']']=143;
	convert['{']=145; convert['|'] =155; convert['}']=134;
      }
    } else if (dkopt == -1 ) {
      if (from_cp==Latin1) {
	convert[198]='['; convert[216]='\\'; convert[197]=']';
	convert[230]='{'; convert[248]='|' ; convert[229]='}';
      } else {
	convert[146]='['; convert[157]='\\'; convert[143]=']';
	convert[145]='{'; convert[155] ='|'; convert[134]='}';
      }
    }
    /* skip Ascii=0 */
    if (unmap) for (i=1; i < 256; i++) if (! convert[i] ) convert[i]=unmap;
    if (lx80opt) /* convert from EPSON-LX80 graphics to IBM */
       for (i=0x80; i<0xA0; i++) convert[i]=lx80tab[i & 0x1f] ;
  }

  if (errorflg) {
	errormsg(errorflg);
  } else {
    do_convert( fin, fout);
  }
  return 0;
}
